#version 430

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out vec3 worldPosition;
out vec3 worldNormal;
out vec2 faceUv;
out vec4 FragPosLightSpace;

uniform mat4 projectionViewMat;
uniform mat4 modelMat;
uniform mat4 lightSpaceMatrix;


void main() {
  gl_Position= projectionViewMat * modelMat * vec4( position, 1.0 );
  
  worldPosition= vec3(modelMat* vec4(position, 1.0));
  worldNormal= vec3(transpose(inverse(modelMat)) * vec4( normal, 1.0 ));
  faceUv= uv;
  FragPosLightSpace = lightSpaceMatrix * vec4(worldPosition, 1.0);
}
